#include <stdio.h>
#include <windows.h>

/* The type of the function exported from our DLL. */
typedef void __cdecl rt_win_dll_entry_type(void);

  
/* Assume my_main() is part of the DSO rt_test.dll that is loaded
  dynamically. */
int __cdecl main(int argc,char *argv[])
{
  int result;
  HMODULE hModule = NULL; // handle to rt.dll
  rt_win_dll_entry_type *my_main_ptr = NULL;

  /* Do application specific initializations here. */

  /* Load the DLL. */

  hModule = LoadLibraryEx("rt_static_shared.dll", 0, LOAD_LIBRARY_SEARCH_DEFAULT_DIRS);
  if (hModule == NULL) {
    goto barf;
  }
  /* Find the exported function in the loaded DLL. */
  my_main_ptr = (rt_win_dll_entry_type*) GetProcAddress(hModule,"rt_win_dll_entry");
  if (my_main_ptr == NULL) {
    goto barf;
  }

  /* Then initialize Prolog run-time and call predicates etc. */
  my_main_ptr();

 cleanup:

  if (hModule != NULL) {
    FreeLibrary(hModule);
    hModule = NULL;
  }
  return 0;
  
 barf:
  result = 42;
  goto cleanup;
}
